<?php

// ************************************************************************
//PHPrcon - PHP script collection to remotely administrate and configure Halflife and HalflifeMod Servers through a webinterface
//Copyright (C) 2002  Henrik Beige
//
//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.
//
//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.
//
//You should have received a copy of the GNU Lesser General Public
//License along with this library; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// ************************************************************************

  global $pnRCON_Theme, $pnRCON_ServerIP, $pnRCON_ServerPort, $pnRCON_Style, $pnRCON_RCONPassword;

  //Includes
  include($pnRCONPath . "classes/rcon_hl_net.inc");
  include($pnRCONPath . "classes/template.inc");

  //neues Template erzeugen
  $tpl = new Template($pnRCONPath . "themes/" . $pnRCON_Theme, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "main" => "main.ihtml",
    "servercommand" => "servercommand.ihtml"
  ));

  $tpl->set_var(array(
	  "MODULENAME" => "modules.php?name=" . $module_name,
	  "TEMPLATESTYLE" => "$pnRCON_Style"
	));
	
  //Sprachblcke setzen
  include($pnRCONPath . "includes/language.psn");

  //get command
  if(isset($_POST["command"]))
    $command = $_POST["command"];
  else if(isset($_GET["command"]))
    $command = $_GET["command"];
  else
    $command = "";
    
  //parse helptext
  $command = trim(urldecode($command));
  $tpl->set_var(array(
    "CALLTYPE" => "",
    "COMMANDOUTPUT" => "",
    "COMMAND" => $command
  ));


  //connect to current server
  $server = new Rcon();

  //build connection to Gameserver
  $server->Connect($pnRCON_ServerIP, $pnRCON_ServerPort, $pnRCON_RCONPassword);

  //Get Server Info
  $info = $server->Info();

  //Not connected error
  if(!$info)
  {
    $tpl->parse("CONTENT", "generalnotconnected", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }

  //Action
  $result = "";

  if(isset($_POST["action"]) && $_POST["action"] == 1 || isset($_GET["action"]) && $_GET["action"] == 1 )
  {
    //set rcon command
    $result = $server->RconCommand($command);

    //Not connected error
    if(!$server->IsConnected())
    {
      $tpl->parse("CONTENT", "generalnotconnected", false);
      $tpl->parse("OUT", "main", false);
      $tpl->p("OUT");
      exit;
    }

    //put out output :)
    if(isset($_POST["commandoutput"]))
      $output = $_POST["commandoutput"];
    else
      $output = "";

    $output = StripSlashes("$output\nCommando: $command\n$result\n______________________________________________________________\n\n");
    $tpl->set_var("COMMANDOUTPUT", $output);

  }

  else if(isset($_GET["command"]) && trim($_GET["command"]) != "")
  {
    $tpl->set_var("COMMAND", $_GET["command"]);
    $tpl->parse("CALLTYPE", "rconcommandnotexecuted", false);
  }

  //close connection
  $server->Disconnect();

  //Bad rcon password
  if(trim($result) == "Bad rcon_password.")
  {
    $tpl->parse("CONTENT", "generalbadrcon", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }


  //display global server info
  $tpl->set_var(array(
    "TCPIP" => $info["ip"] ,
    "HOSTNAME" => $info["name"],
    "MAP" => $info["map"],
    "PLAYERS" => ($info["activeplayers"] . " active  / " . $info["maxplayers"] . " max")
  ));


  //parse content in main template
  $tpl->parse("CONTENT", "servercommand", false);

  //parse everything and print it
  $tpl->parse("OUT", "main", false);
  $tpl->p("OUT");

?>