<?php

// ************************************************************************
//PHPrcon - PHP script collection to remotely administrate and configure Halflife and HalflifeMod Servers through a webinterface
//Copyright (C) 2002  Henrik Beige
//
//This library is free software; you can redistribute it and/or
//modify it under the terms of the GNU Lesser General Public
//License as published by the Free Software Foundation; either
//version 2.1 of the License, or (at your option) any later version.
//
//This library is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//Lesser General Public License for more details.
//
//You should have received a copy of the GNU Lesser General Public
//License along with this library; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// ************************************************************************

  global $pnRCON_Theme, $pnRCON_ServerIP, $pnRCON_ServerPort, 
	  $pnRCON_Style, $pnRCON_RCONPassword, $pnRCON_MapPages,
		$pnPStats_MapURL;

  //Includes
  include($pnRCONPath . "classes/rcon_hl_net.inc");
  include($pnRCONPath . "classes/template.inc");

  //neues Template erzeugen
  $tpl = new Template($pnRCONPath . "themes/" . $pnRCON_Theme, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "main" => "main.ihtml",
    "servermaps" => "servermaps.ihtml"
  ));

  $tpl->set_var(array(
	  "MODULENAME" => "modules.php?name=" . $module_name,
	  "TEMPLATESTYLE" => "$pnRCON_Style"
	));
	
  //Sprachblcke setzen
  include($pnRCONPath . "includes/language.psn");

  //Blocks definieren
  $tpl->set_block("servermaps", "map", "DUMMY");
  $tpl->set_block("servermaps", "dir", "DUMMY");
  $tpl->set_block("servermaps", "servertype", "SERVERTYPE");

  //parse helptext
  $tpl->set_var(array(
    "DUMMY" => "",
    "SERVERTYPE" => ""
  ));


  //connect to current server
  $server = new Rcon();
  $server->Connect($pnRCON_ServerIP, $pnRCON_ServerPort, $pnRCON_RCONPassword);

  //Get Server maps
  $maps = $server->ServerMaps($pnRCON_MapPages);  //***???

  //Get Server Info
  $info = $server->Info();
  if(!$info) {
	  echo "\$info is empty!";
	}

  //Not connected error
  if(!$maps)
  {
    $tpl->parse("CONTENT", "generalnotconnected", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }

  //send mapchange command
  if(isset($_GET["action"]) && $_GET["action"] == "change")
  {
    //send command
    $result  = $server->RconCommand("changelevel " . $_GET["mapname"]);

    //specify feedback
    if(strstr($result, "failed"))
      $feedback = "servermapsnochange";
    else
      $feedback = "servermapschange";
  }
  else
    $feedback = "";

  //close connection
  $server->Disconnect();

  //Bad rcon password
  if(!is_array($maps) && trim($maps) == "Bad rcon_password.")
  {
    $tpl->parse("CONTENT", "generalbadrcon", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }


  //display global server info
  $tpl->set_var(array(
    "TCPIP" => $info["ip"] ,
    "HOSTNAME" => $info["name"],
    "MAP" => $info["map"],
    "PLAYERS" => ($info["activeplayers"] . " active  / " . $info["maxplayers"] . " max")
  ));


  //get all servertypes
  $servertypes = array_keys($maps);

  //output maps by servertypes
  for($i = 0; $i < sizeof($servertypes); $i++)
  {
    //get all maps for one servertype
    $servermaps = $maps[$servertypes[$i]];

    //output directory name
    $tpl->set_var("DIRECTORY" , $servertypes[$i]);
    $tpl->parse("ROWS", "dir");

    //sort maps
    sort($servermaps);

    //output all maps
    $row1 = "";
    for($j = 0; $j < sizeof($servermaps); )
    {

      //toggle row color
      if($row1 == "pnRow_One") {
        $row1 = "pnRow_Two";
        $row2 = "pnRow_One";
        $row3 = "pnRow_Two";
      } else {
        $row1 = "pnRow_One";
        $row2 = "pnRow_Two";
        $row3 = "pnRow_One";
			}

			$map1 = $servermaps[$j];
			$mapimg1 = "<IMG src=\"$pnPStats_MapURL$map1.gif\" alt=\"$map1\" border=0 width=160 height=120>";
			if ($j+1 < sizeof($servermaps)) {
			  $map2 = $servermaps[$j+1];
  			$mapimg2 = "<IMG src=\"$pnPStats_MapURL$map2.gif\" alt=\"$map2\" border=0 width=160 height=120>";
			} else {
			  $map2 = "";
  			$mapimg2 = "";
			}
			if ($j+2 < sizeof($servermaps)) {
			  $map3 = $servermaps[$j+2];
  			$mapimg3 = "<IMG src=\"$pnPStats_MapURL$map3.gif\" alt=\"$map3\" border=0 width=160 height=120>";
			}	else {
			  $map3 = "";
  			$mapimg3 = "";
			}
			
      //fill template
      $tpl->set_var(array(
        "MODULENAME1" => "modules.php?name=" . $module_name,
        "ROWSTYLE1" => $row1,
        "MAPNAME1" => $map1,
				"MAPIMG1" => $mapimg1,
				"MODULENAME2" => "modules.php?name=" . $module_name,
        "ROWSTYLE2" => $row2,
        "MAPNAME2" => $map2,
				"MAPIMG2" => $mapimg2,
				"MODULENAME3" => "modules.php?name=" . $module_name,
        "ROWSTYLE3" => $row3,
        "MAPNAME3" => $map3,
				"MAPIMG3" => $mapimg3
      ));
      $tpl->parse("ROWS", "map", true);

			$j = $j + 3;
    } //for($j = 0; $j < sizeof($servermaps); $j++)

    $tpl->parse("SERVERTYPE", "servertype", true);

  } //for($i = 0; $i < sizeof($servertypes); $i++)


  //parse content in main template
  $tpl->parse("FEEDBACK", $feedback, false);

  //parse content in main template
  $tpl->parse("CONTENT", "servermaps", false);

  //parse everything and print it
  $tpl->parse("OUT", "main", false);
  $tpl->p("OUT");

?>
